<script setup lang="ts">
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { TableColumnsType, message } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import useI18n from '@/hooks/useI18n';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useNeInfoStore from '@/store/modules/neinfo';
import { useRoute } from 'vue-router';
import { listAMFNblist } from '@/api/neData/amf';
import { listMMENblist } from '@/api/neData/mme';
const neInfoStore = useNeInfoStore();
const route = useRoute();
const { t } = useI18n();

/**网元参数 */
let neCascaderOptions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**网元ID */
  neId: '',
  /**网元类型 */
  neType: ['', ''],
  /**GNB_ID */
  id: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neId: '',
    id: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'small',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns = ref<TableColumnsType>([
  {
    title: 'Radio ID',
    dataIndex: 'id',
    align: 'center',
    width: 100,
  },
  {
    title: 'NE Name',
    dataIndex: 'neName',
    align: 'left',
    resizable: true,
    width: 200,
    minWidth: 150,
    maxWidth: 400,
  },
  {
    title: 'UE Number',
    dataIndex: 'ueNum',
    align: 'center',
    width: 100,
  },
  {
    title: 'Radio Name',
    dataIndex: 'name',
    align: 'left',
    resizable: true,
    width: 200,
    minWidth: 150,
    maxWidth: 400,
  },

  {
    title: 'Radio Address',
    dataIndex: 'address',
    align: 'left',
  },
]);

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

let promises = ref<any[]>([]);
/**查询列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  if (!queryParams.neType) {
    tableState.data = [];
    promises.value = [];
    //同时获取45G基站信息 且在每条信息中添加45G字段(原始数据没有) 已经筛选后的
    neCascaderOptions.value.map((item: any) => {
      item.children.forEach((child: any) => {
        let resq = null;
        let s = {
          neId: child.neId,
          neType: child.neType,
          nbId: queryParams.id,
          pageNum: queryParams.pageNum,
          pageSize: 10000,
        };
        if (child.neType === '5G' || child.neType === 'AMF') {
          resq = listAMFNblist(s);
        }
        if (child.neType === '4G' || child.neType === 'MME') {
          resq = listMMENblist(s);
        }
        if (resq !== null) {
          promises.value.push(
            resq.then(res => {
              // 添加 neName 字段到每一项数据
              if (res.code === RESULT_CODE_SUCCESS) {
                res.data.forEach((row: any) => {
                  row.neName = `${child.neType}_${child.neId}`;
                });
              }
              return res;
            })
          );
        }
      });
    });

    Promise.allSettled(promises.value).then(results => {
      results.forEach(result => {
        if (result.status === 'fulfilled') {
          const allBaseData = result.value;
          if (
            allBaseData.code === RESULT_CODE_SUCCESS &&
            Array.isArray(allBaseData.rows)
          ) {
            // 处理成功结果
            tablePagination.total += allBaseData.total;
            tableState.data = [...tableState.data, ...allBaseData.rows];
            if (
              tablePagination.total <=
                (queryParams.pageNum - 1) * tablePagination.pageSize &&
              queryParams.pageNum !== 1
            ) {
              tableState.loading = false;
              fnGetList(queryParams.pageNum - 1);
            }
          } else {
            //AMF返回404是代表没找到这个数据 GNB_NOT_FOUND
            tablePagination.total = 0;
            tableState.data = [];
          }
          tableState.loading = false;
        }
      });
    });

    return;
  }

  let toBack: Record<string, any> = {
    neType: queryParams.neType[0],
    neId: queryParams.neType[1],
    nbId: queryParams.id,
    pageNum: queryParams.pageNum,
    pageSize: queryParams.pageSize,
  };
  let resq = null;
  if (queryParams.neType[0] === '5G' || queryParams.neType[0] === 'AMF') {
    resq = listAMFNblist(toRaw(toBack));
  }
  if (queryParams.neType[0] === '4G' || queryParams.neType[0] === 'MME') {
    resq = listMMENblist(toRaw(toBack));
  }
  if (resq === null) return;
  resq.then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }

      tablePagination.total = res.data.length;
      tableState.data = res.data;

      res.data.forEach((item: any) => {
        item.neName = queryParams.neType.join('_');
      });

      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    } else {
      //AMF返回404是代表没找到这个数据 GNB_NOT_FOUND
      tablePagination.total = 0;
      tableState.data = [];
    }
    tableState.loading = false;
  });
}

onMounted(() => {
  // 获取网元网元列表
  neInfoStore
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS) {
        if (res.data.length > 0) {
          // 过滤不可用的网元
          for (const item of neInfoStore.getNeCascaderOptions) {
            if (!['AMF', 'MME'].includes(item.value)) continue;
            const v = JSON.parse(JSON.stringify(item));

            if (v.label === 'AMF') {
              v.label = '5G';
            }
            if (v.label === 'MME') {
              v.label = '4G';
            }
            neCascaderOptions.value.push(v);
          }

          if (neCascaderOptions.value.length === 0) {
            message.warning({
              content: t('common.noData'),
              duration: 2,
            });
            return;
          }

          // 无查询参数neType时 默认选择AMF
          const queryNeType = (route.query.neType as string) || '5G';
          const item = neCascaderOptions.value.find(
            s => s.value === queryNeType
          );
          if (item && item.children) {
            const info = item.children[0];
            queryParams.neType = [info.neType, info.neId];
          } else {
            const info = neCascaderOptions.value[0].children[0];
            queryParams.neType = [info.neType, info.neId];
          }
        }
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetList();
    });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item name="neId" :label="t('views.neUser.base5G.neType')">
              <a-cascader
                v-model:value="queryParams.neType"
                :options="neCascaderOptions"
                :placeholder="t('common.selectPlease')"
                @change="fnGetList(1)"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item label="Radio ID" name="id">
              <a-input v-model:value="queryParams.id" allow-clear></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title> </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ y: 'calc(100vh - 480px)' }"
        @resizeColumn="(w:number, col:any) => (col.width = w)"
      >
      </a-table>
    </a-card>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
